/*******************************************************

CodeWizardAVR V3.10 Evaluation www.hpinfotech.com

Project :  .1     RC5  .   PORTB.0  gnd
Version : 
Date    : 06.04.2014
Author  : www.proavr.narod.ru
Company : 
Comments: http://roboforum.ru/forum2/topic14113.html


Chip type               : ATmega16A
Program type            : Application
AVR Core Clock frequency: 8 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*******************************************************/

#include <mega16a.h>
//#include <io.h>
#include <delay.h>
//#include <interrupt.h>

//  
#define Tmin 40 //  
#define Tmax 68
#define TminK 22 //  
#define TmaxK 34

unsigned char sct_bit = 0; //   RC5
unsigned char RC5_buffer [14]; //  RC5
unsigned char centre = 0; //   
unsigned char not_korr = 0; //    
unsigned char Timer = 0; //    
unsigned char command = 0; //   
//char s = 0;


//   
void rc5_cl_buf(void)
{
unsigned char i = 0; 
for (i=0; i<14; i++)
{
}
} 

//   
void rc5_ti_stop(void)
{
GICR = 0x00;
TCCR0 = 0x00;
TCNT0 = 0;
sct_bit = 0;
} 


//     0 
interrupt [TIM0_OVF] void timer0_ovf_isr(void) 
{
rc5_ti_stop(); //  
rc5_cl_buf(); // 
GICR |= (1 << INT0); //    INT0
GIFR |= (1 << INTF0); //   ( )
} 

//    INT0
interrupt [EXT_INT0] void ext_int0_isr(void)
{
Timer = TCNT0; //    
TCNT0 = 0; //  
not_korr = 1; 

if(sct_bit==0)
{
TCCR0 |= (1 << CS02); //   (31.250 KHz    8  )
RC5_buffer [sct_bit] = !(PIND&(1 << PORTD2)); //  .
sct_bit++; // +1    
centre = 1; 
}
else
{
//   
if ((Timer > TminK)&&(Timer < TmaxK))
{
if (centre) 
{
centre = 0;
not_korr = 0; 
}
else
{
centre = 1;
RC5_buffer [sct_bit] = !(PIND&(1 << PORTD2));
sct_bit++;
not_korr = 0;
}
}
//   
if ((Timer > Tmin)&&(Timer < Tmax))
{
RC5_buffer [sct_bit] = !(PIND&(1 << PORTD2));
sct_bit++;
not_korr = 0;
}

if (not_korr == 1)
{ //          
rc5_ti_stop();
rc5_cl_buf(); //  
}

if (sct_bit == 14) //  14  
{ //     
rc5_ti_stop(); // 
//   
command = (RC5_buffer [8] << 5)|(RC5_buffer [9] << 4)|
(RC5_buffer [10] << 3 )|(RC5_buffer [11] << 2)|
(RC5_buffer [12] << 1)|RC5_buffer [13];


if(command==01) {
PORTB.0=1; //      -  "1"
                }
else {
PORTB.0=0; //     "1"
     }

//  IF-ELSE -  !
command = 0;


/* s++;
delay_ms(100);
if(s > 1)
s = 0;  */


}


GICR |= (1 << INT0); //     INT0
GIFR |= (1 << INTF0); //      INT0
} 
}

void main(void)
{
DDRB = 0xFF; // 
PORTB = 0x00;
DDRD &= ~(1 << PORTD2); //  
DDRD = 0x00;




TIMSK |= (1 << TOIE0); //    0

GICR |= (1 << INT0); //     INT0
MCUCR |= (1 << ISC00); //    
GIFR |= (1 << INTF0); //   

#asm("sei"); //   


while(1)
{
command = 0;   //   
delay_ms(300); //  ,       
PORTB.0=0;     //   300     . 1 -  . 
}

}